#include <stdio.h>
#include <stdlib.h>

#define TABLA 5
#define NR_HAJO 3
#define URES '0'
#define HAJO 'H'
#define TALALT 'S'
#define NEMTALALT 'X' 

//0-nincs hajo, 1-van hajo, 2-rossz index
int vanhajo (char t[TABLA][TABLA], int i, int j);
//Tbla feltltse hajkkal
void createtabla(char t[TABLA][TABLA]);
//Kirajzolja a tblt. rejtett=1 esetn az p hajkat nem rajzolja
void drawtabla(char t[TABLA][TABLA],int rejtett);
//Megszmolja, hogy hny haj van mg
int  maradekhajo(char t[TABLA][TABLA]);
//0-nem tallt 1-tallt
void loves(char t[TABLA][TABLA]);

int main(int argc, char *argv[]) {
	char tabla[TABLA][TABLA];
	createtabla(tabla);
	do{
	  drawtabla(tabla,1);
	  loves(tabla);
    } while(maradekhajo(tabla));
	drawtabla(tabla,0);
	return 0;
}

void loves(char t[TABLA][TABLA])
{
	int i,j;
	printf("\nAdjon meg ket koordinatat:");
	if (scanf("%d %d",&i,&j)!=2)
	{
		scanf("%*[^\n]");
		return;
	}
	if (vanhajo(t,i,j)==2) 
	  printf("Rossz koordinata");
	else  
	switch(t[i][j])
	{
		case URES: 
		        t[i][j]=NEMTALALT;
		case NEMTALALT:     
			    printf("Nem talalt!\n");
		        break;
		case HAJO: 
		        t[i][j]=TALALT;
		        printf("Talalt!\n");
		        break;
		case TALALT: 		        
		        printf("Meg egyszer belelott!\n");
		        break;
	}
}

void drawtabla(char t[TABLA][TABLA],int rejtett)
{
	int i,j;char c;
	printf("\n");
	for (i=0;i<TABLA;i++)
	{
	for (j=0;j<TABLA;j++)
	  {
	  	if (rejtett)
		  c=(vanhajo(t,i,j))?URES:t[i][j];
		  else
		  c=t[i][j];
	    printf("%c",c); 
      }
	 printf("\n");
    }
}

void createtabla(char t[TABLA][TABLA])
{
	int h,i,j;
	
	for (i=0;i<TABLA;i++)
	for (j=0;j<TABLA;j++)
	  t[i][j]=URES; 
	for (h=0;h<NR_HAJO;h++)
	{ 
	   do{
	   	  i=rand()%TABLA;
	   	  j=rand()%TABLA;
	   } while (vanhajo(t,i,j));
	   t[i][j]=HAJO;
	}
}

int vanhajo (char t[TABLA][TABLA], int i, int j)
//0-nincs hajo, 1-van hajo, 2-rossz index
{
    if (i<0||j<0||i>=TABLA||j>=TABLA) 
    		return 2;
    return (t[i][j]==HAJO)?1:0;		
}

int maradekhajo(char t[TABLA][TABLA])
{
    int i,j,h=0;
		for (i=0;i<TABLA;i++)
	    for (j=0;j<TABLA;j++)
	      if (t[i][j]==HAJO) h++;
	return h;	    
}

