#include <stdio.h>
#include <stdlib.h>
#include <math.h>

struct Tpont{int x; int y;};

int feltolt(char filename[]);
void tavolsag(char filename[]);
struct Tpont legkozelebb(char filename[]);

int main(int argc, char *argv[]) {
	char fn[]="pontok.dat";
	feltolt(fn);
	tavolsag(fn);
	//tsrt szekci:
	  struct Tpont p;
	  p=legkozelebb(fn);
	  if (p.x!=-100)
	    printf("A (10,10)-hez legkozelebbi pont: %4d %4d\n",p.x,p.y);
	return 0;
}

int feltolt(char filename[])
{
   FILE *f;
   struct Tpont pont;
   int i;
   f=fopen(filename,"wb");
   if (NULL==f)
   {
   	  return 1;
   }
   for (i=0;i<20;i++)
      {
      	pont.x=rand()%21-10;
      	pont.y=rand()%21-10;
      	fwrite(&pont,sizeof pont,1,f);
      }	
   fclose(f);
   return 0;	
}

void tavolsag(char filename[])
{
   FILE *f;
   struct Tpont pont;
   float tav,beker;
   f=fopen(filename,"rb");
   if (NULL==f) 
   {
   	 printf("Hiba a file megnyitsakor");
   	 return;
   }
   printf("Kerek egy tavolsagot:");
   scanf("%f",&beker);
   
   while (1==fread(&pont,sizeof pont,1,f))
   {
   	   tav=sqrt(pow(pont.x,2.0)+pow(pont.y,2.0));
   	   if (tav<=beker)
   	   printf("%4d %4d\n",pont.x,pont.y);
   }
   fclose(f);   
}

struct Tpont legkozelebb(char filename[])
{
	struct Tpont pmin={-100,-100},pont;
	float tav,dmin=10000000.0f; //Nagyobb, mint az elmleti maximum
	FILE *f;
	 f=fopen(filename,"rb");
   if (NULL==f) 
   {
   	 printf("Hiba a file megnyitsakor");
   	 return ;
   }
   while (1==fread(&pont,sizeof pont,1,f))
   {
   	   tav=sqrt(pow(10-pont.x,2.0)+pow(10-pont.y,2.0));
   	   if (tav<=dmin)
   	   {
   	   	  dmin=tav;
   	   	  pmin=pont;
   	   }   	   
   }
   fclose(f);   
   return pmin;   
}

