#include <stdio.h>
#include <stdlib.h>

#define ALMA 0
#define KORTE 1
#define BANAN 2
struct TKosar{int alma; int korte; int banan};

int feltolt(char filename[]);
void legtobb(char filename[]);
void keres(char filename[]);

int main(int argc, char *argv[]) {
	char fn[]="kosarak.dat";
	feltolt(fn);
	legtobb(fn);
	keres(fn);
}

int feltolt(char filename[])
{
   FILE *f;
   struct TKosar kosar;
   int i;
   
   f=fopen(filename,"wb");
   if (NULL==f)
   {
   	  return 1;
   }
   for (i=0;i<45;i++)
      {
      	kosar.alma=rand()%10;
      	kosar.korte=rand()%10;
      	kosar.banan=rand()%10;
      	fwrite(&kosar,sizeof kosar,1,f);
      }	
   fclose(f);
   return 0;	
}

void legtobb(char filename[])
{
   FILE *f;
   struct TKosar kosar;
   int melyik,jo;
   f=fopen(filename,"rb");
   if (NULL==f) 
   {
   	 printf("Hiba a file megnyitsakor");
   	 return;
   }
   printf ("Melyik gyumolcsbol legyen a legtobb? (0-alma, 1-korte, 2-banan)");
   scanf("%d",&melyik);
   
   while (1==fread(&kosar,sizeof kosar,1,f))
   {
   	   
   	   switch (melyik)
   	   {
   	   	  case ALMA:  jo=(kosar.alma>kosar.korte && kosar.alma>kosar.banan); break;
		  case KORTE: jo=(kosar.korte>kosar.alma && kosar.korte>kosar.banan); break;
		  case BANAN: jo=(kosar.banan>kosar.korte && kosar.banan>kosar.alma); break;   	   	  
   	   }
   	   if (jo)
   	   printf("alma:%d korte:%d banan:%d\n",kosar.alma,kosar.korte,kosar.banan);
   }
   fclose(f);   
}

void keres(char filename[])
{
	
   FILE *f;
   struct TKosar kosar;
   f=fopen(filename,"rb");
   if (NULL==f) 
   {
   	 printf("Hiba a file megnyitsakor");
   	 return;
   }
   printf("Keres fv:\n");
   while (1==fread(&kosar,sizeof kosar,1,f))
   {
   	   if (kosar.korte==kosar.alma+kosar.banan ||
		   kosar.alma==kosar.korte+kosar.banan ||
		   kosar.banan==kosar.alma+kosar.korte )
        	   printf("alma:%d korte:%d banan:%d\n",kosar.alma,kosar.korte,kosar.banan);
   }
   fclose(f);   
}
