#include <stdio.h>
#include <stdlib.h>

/* run this program using the console pauser or add your own getch, system("pause") or input loop */

#define FILENAME "aruk.dat"

struct TAru{char nev[10];int db;int ar;};

void feltolt();
void kiir();
void kiad();
void keves();

int main(int argc, char *argv[]) {
	int valasz;
	do
	{
	  valasz=10;
	  printf("----MENU:----\n")	;
	  printf("0-Letrehozas\n1-Listazas\n2-Kiadas\n3-Kevesek listazasa\n4-Kilepes\n");	
	  printf("Valasszon a menubol!");
	  scanf("%d",&valasz);
	  switch (valasz)
	  {
	  	case 0: feltolt();break;
	  	case 1: kiir();break;
	  	case 2: kiad();break;
	  	case 3: keves();break;
	  	case 4: break;
	  	default: printf("Rossz valasztas!\n");
	  	fflush(stdin);
	  }
	}while (valasz!=4);
	
	return 0;
}

void feltolt()
{
	FILE *f;
	int i;
	struct TAru aru;
	f=fopen(FILENAME,"wb");
	if (NULL==f)
	  {
	  	printf("Nem sikerult letrehozni a file-t!\n");
	  	return;
	  }
	strcpy(aru.nev,"_");  //csak a lezr nulla miatt
	for (i=0;i<5;i++)  
	{
		aru.nev[0]='a'+rand()%26;
		aru.db=rand()%100;
		aru.ar=rand()%10000;
		fwrite(&aru,sizeof aru,1,f);
	}
	fclose(f);	
}

void kiir()
{
	FILE *f;
	int i;
	struct TAru aru;
	f=fopen(FILENAME,"rb");
	if (NULL==f)
	  {
	  	printf("Nem sikerult megnyitni a file-t!\n");
	  	return;
	  }
	printf("----Keszlet:----\n");  
	while (1==fread(&aru,sizeof aru,1,f)) 
	   {
	   	  printf("Nev: %10s Db: %3d Ar:%3d Ft\n",aru.nev,aru.db,aru.ar);
	   }
	printf("----------------\n");
	fclose(f);
}

void kiad()
{
	int mennyit,siker=0;
	
	char arunev[10];
	FILE *f;
	struct TAru aru;
	f=fopen(FILENAME,"rb+");
	if (NULL==f)
	  {
	  	printf("Nem sikerult megnyitni a file-t!\n");
	  	return;
	  }
	printf("Adja meg az aru nevet:")  ;
	scanf("%s",&arunev);
	printf("Mennyit ad el?")  ;
	scanf("%d",&mennyit);
	while (1==fread(&aru,sizeof aru,1,f)) 
	{
	   if (strcmp(arunev,aru.nev)==0)
	   {
	       	if (mennyit>aru.db) 
	       	{
	       		printf("Nincs eleg belole.\n");
	       		break;
	       	}
	       	aru.db-=mennyit;    
	       	fseek(f,-1*sizeof aru,SEEK_CUR);
	       	fwrite(&aru,sizeof aru,1,f);
	       	printf("%d darabot kiadtam.\n",mennyit);
	       	siker=1;
	       	break;
	   }
	}
	if (!siker) 
	   printf("A muvelet sikertelen.\n");
	fclose(f);
}

void keves()
{
	FILE *f;
	int i;
	struct TAru aru;
	f=fopen(FILENAME,"rb");
	if (NULL==f)
	  {
	  	printf("Nem sikerult megnyitni a file-t!\n");
	  	return;
	  }
	printf("----Keszlet:----\n");  
	while (1==fread(&aru,sizeof aru,1,f)) 
	   {
	   	  if (aru.db<5)
	   	  printf("Nev: %10s Db: %3d Ar:%3d Ft\n",aru.nev,aru.db,aru.ar);
	   }
	printf("----------------\n");
	fclose(f);
}

